"""Class to query database info

This is DB2 specific,  tested against DB2 7.1

Author: Philipp Auersperg <phil@bluedynamics.com>
"""

import InfoBase
import string

class Info(InfoBase.Info):
    # mmm... standards.
    queryTables = 'select tabname from syscat.tables'
    queryColumns = "select colname, typename, length, nulls from syscat.columns where tabname = '%s' "


    def type(self, table, column):
	"""Maps database types to #sqlvar types

	Should be smarter (i.e. use type=nb)
	"""
	for i in self.columnsData[table]:
	    if i[0] == column:
		colInfo = i
		break
	# in `queryColumns', second col is type
	
	type = string.lower(colInfo[1]) 
	print 'type:',type,column
	if ((string.find(type, "char") != -1) or #gets char and varchar
	    (string.find(type, "date") != -1) or
	    (string.find(type, "enum") != -1) ):
	    if self.nullable(table, column):
		return 'nb'
	    else:
		return 'string'
	if ( (string.find(type, "rowid") != -1) or
	    (string.find(type, "number") != -1) ):
	    return 'int'
	
	#else
	return 'float'
    
    def nullable(self, table, column):
	"This is really DB2 specific"
	for i in self.columnsData[table]:
	    if i[0] == column:
		colInfo = i
		break
	if colInfo[3] == "Y": #3 is the pos for null info
	    return 'optional'
	return ''

